Compare commits

..

35 Commits

Author SHA1 Message Date
Wojtek Mach d85df626dd Fix setting INSTALL_DIR_FOR_OTP (#141) 2022-09-16 10:28:57 +02:00
Paulo F. Oliveira 6b2f8153b4 Crash on invalid Elixir+OTP combo (#134)
* Prevent "future" errors when choosing incompatible Elixir v. OTP versions

* Fix tests as per GitHub Actions' output

* Make test elixir `master` strict

It has no -otp- in the name
2022-09-13 08:21:46 +01:00
Wojtek Mach 7dd0d763a8 Install OTP on Windows to a local directory (#139) 2022-09-12 16:40:00 +02:00
Louis Pilfold ee0fa0b672 Update for latest Gleam (#138)
* Update for latest Gleam

- Gleam releases now use LLVM triplets for platforms so the download
  URLs have been updated accordingly.
- Gleam's rebar3 support has been removed.

This change means that future versions of this action cannot download
older versions of Gleam. I can make it backwards compatible, but I will
need help from someone who can convert the shell script into PowerShell
for Windows.

* Support older Gleam versions

* Remove rebar from Gleam
2022-09-12 15:35:29 +01:00
github-actions[bot] 4518ce17a4 Update 3rd party licenses (#135)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-08-22 14:19:29 +01:00
dependabot[bot] 1fddfab461 Bump @actions/core from 1.6.0 to 1.9.1 (#133)
* Bump @actions/core from 1.6.0 to 1.9.1

Bumps [@actions/core](https://github.com/actions/toolkit/tree/HEAD/packages/core) from 1.6.0 to 1.9.1.
- [Release notes](https://github.com/actions/toolkit/releases)
- [Changelog](https://github.com/actions/toolkit/blob/main/packages/core/RELEASES.md)
- [Commits](https://github.com/actions/toolkit/commits/HEAD/packages/core)

---
updated-dependencies:
- dependency-name: "@actions/core"
  dependency-type: direct:production
...

Signed-off-by: dependabot[bot] <support@github.com>

* Update what dependabot didn't

Signed-off-by: dependabot[bot] <support@github.com>
Co-authored-by: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
Co-authored-by: Paulo F. Oliveira <paulo.ferraz.oliveira@gmail.com>
2022-08-22 11:20:01 +01:00
github-actions[bot] 6942ea249f Update 3rd party licenses (#132)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-08-22 11:11:31 +01:00
Paulo F. Oliveira 69fb25ba7e Ease consumption (#125)
Don't take `maint-` -prefixed versions into account unless they're asked for it
specifically
At the same time, while fetching versions, make sure we identify them better so that
25 does not end up pulling maint-25 instead of OTP-25.0, as it should
2022-08-01 13:23:47 +01:00
Paulo F. Oliveira caa49b0658 Try current state with Ubuntu 22.04 (#124) 2022-07-12 21:59:53 -05:00
github-actions[bot] ae1b3f83c0 Update 3rd party licenses (#126)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-07-11 12:27:42 +01:00
Kian-Meng Ang 79c4ce944c Update README: signal OTP-25 as a working version (#122)
See https://github.com/erlef/setup-beam/pull/118
2022-06-27 12:44:56 +01:00
Michał Łępicki a7fc45fd2d Fix mispaste in README.md (#119) 2022-05-31 08:48:37 -05:00
Paulo F. Oliveira ac7b7d515b Test on top of Erlang/OTP 25+ (not RC) (#118)
* Add Erlang/OTP 25+ (not RC) to tests

* Test a specific combo

And a strict version

* Allow testing "edge" cases

We weren't taking our own considerations into account for version strictness
We want to be able to test cases where we use -otp- (if the consumer is doing
it, at least they have to use _strict_ to assert their decision)
2022-05-30 15:11:49 +01:00
Javier Garea b8427d3a11 Fix wrong environment variable descriptions in the README (#115) 2022-05-12 13:46:50 +01:00
github-actions[bot] c9256cba97 Update 3rd party licenses (#114)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-05-12 13:40:21 +01:00
github-actions[bot] 9627051904 Update 3rd party licenses (#113)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-05-09 17:24:54 +01:00
github-actions[bot] cb4115cacb Update 3rd party licenses (#112)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-04-26 13:33:03 +01:00
github-actions[bot] 1bf5800962 Update 3rd party licenses (#111)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-04-24 13:22:47 +01:00
Paulo F. Oliveira 311afd9034 Apply security fix as proposed by Dependabot (#110)
* Apply security fix as proposed by Dependabot

I actually went to the developer first, pull request the lib., but then my
update got reject, since the lib. moved to TypeScript (from JavaScript);
still, a new release was done and this might just solve our issue

* Update eslint as warned by GitHub notifications
2022-04-23 20:01:06 +01:00
Paulo F. Oliveira 9d4fdad6a1 Feature/run build dist (#109)
* Remove duplicates

We already have everything we need in 3RD_PARTY_LICENSES

* Be mindful of pull request creators
2022-04-21 23:51:29 +01:00
Bryan Paxton 10d50f7062 Use overwrite modifier on unzip to avoid prompts (#106) 2022-04-21 12:38:31 -05:00
github-actions[bot] 42313cae10 Update 3rd party licenses (#105)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-04-17 10:35:44 -05:00
github-actions[bot] 46b0c79322 Update 3rd party licenses (#104)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-04-13 16:11:09 +01:00
Paulo F. Oliveira 5436ca9587 Keep up with the times (#102)
* Keep up with the times

* Act on local static analysis (and other actions) results

npm run ... from package.json
2022-04-12 18:20:59 +01:00
github-actions[bot] 01cb298fa5 Update 3rd party licenses (#103)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-04-12 16:19:04 +01:00
Paulo F. Oliveira 2e0500f2a5 Handle strings as such (#100)
* Handle strings as such

* Let automation do its thing
2022-04-07 20:27:52 +01:00
github-actions[bot] 3e684c4e0b Update 3rd party licenses (#101)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-04-07 13:07:12 +01:00
github-actions[bot] 380359b6cf Update 3rd party licenses (#97)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-04-04 18:45:55 +01:00
dependabot[bot] 73feb48b6c Bump minimist from 1.2.5 to 1.2.6 (#98)
Bumps [minimist](https://github.com/substack/minimist) from 1.2.5 to 1.2.6.
- [Release notes](https://github.com/substack/minimist/releases)
- [Commits](https://github.com/substack/minimist/compare/1.2.5...1.2.6)

---
updated-dependencies:
- dependency-name: minimist
  dependency-type: indirect
...

Signed-off-by: dependabot[bot] <support@github.com>

Co-authored-by: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
2022-04-04 18:44:47 +01:00
Paulo F. Oliveira c428d8c359 Attempt use on top of Erlang 25.0-rc1 (#93) 2022-02-22 11:09:02 +00:00
Paulo F. Oliveira 2494d08aa0 Add environment variables (#94)
* Allow for Windows'22 container

(win22 is just a guess, at this moment)

* Add environment variables

* Clean up code
2022-02-22 11:05:11 +00:00
Paulo F. Oliveira b28629c519 Allow for Windows'22 container (#91)
(win22 is just a guess, at this moment)
2022-02-22 11:04:38 +00:00
github-actions[bot] ebd945dd40 Update 3rd party licenses (#95)
Co-authored-by: GitHub Actions <actions@user.noreply.github.com>
2022-02-22 10:57:14 +00:00
Paulo F. Oliveira df03a946e0 Fix 3rd party license updater (#92)
Instead of pushing directly (since the main branch is protected) this creates a pull request
2022-02-22 10:54:04 +00:00
Paulo F. Oliveira 6c5caca0fb Update our dependencies to increase security (#88) 2022-01-13 20:49:02 +00:00
41 changed files with 12239 additions and 4435 deletions
-1
View File
@@ -27,7 +27,6 @@ jobs:
- run: npm run shellcheck - run: npm run shellcheck
- run: npm run yamllint - run: npm run yamllint
- run: npm run jslint - run: npm run jslint
- run: npm run licenses
- name: Check if build left artifacts - name: Check if build left artifacts
run: git diff --exit-code run: git diff --exit-code
+71 -10
View File
@@ -21,6 +21,27 @@ jobs:
fail-fast: false fail-fast: false
matrix: matrix:
combo: combo:
- otp-version: '25'
elixir-version: '1'
rebar3-version: '3'
os: 'ubuntu-22.04'
- otp-version: '24'
elixir-version: '1'
rebar3-version: '3'
os: 'ubuntu-22.04'
- otp-version: '25.0'
elixir-version: 'v1.13.4-otp-25'
rebar3-version: '3.18.0'
os: 'ubuntu-latest'
version-type: 'strict'
- otp-version: '25.0'
elixir-version: 'v1.13.4'
rebar3-version: '3.18.0'
os: 'ubuntu-latest'
version-type: 'strict'
- otp-version: '25'
rebar3-version: 'nightly'
os: 'ubuntu-latest'
- otp-version: '24' - otp-version: '24'
rebar3-version: 'nightly' rebar3-version: 'nightly'
os: 'ubuntu-latest' os: 'ubuntu-latest'
@@ -62,6 +83,10 @@ jobs:
otp-version: '23' otp-version: '23'
rebar3-version: '3.14' rebar3-version: '3.14'
os: 'ubuntu-18.04' os: 'ubuntu-18.04'
- elixir-version: 'v1.13.4'
otp-version: '25.0.2'
rebar3-version: '3.19'
os: 'ubuntu-18.04'
- elixir-version: 'v1.10' - elixir-version: 'v1.10'
otp-version: '23' otp-version: '23'
rebar3-version: '3.14' rebar3-version: '3.14'
@@ -70,6 +95,10 @@ jobs:
otp-version: '24' otp-version: '24'
rebar3-version: '3.15' rebar3-version: '3.15'
os: 'ubuntu-20.04' os: 'ubuntu-20.04'
- elixir-version: 'v1.13.4'
otp-version: '25.0.2'
rebar3-version: '3.19'
os: 'ubuntu-20.04'
- elixir-version: 'v1.11.0' - elixir-version: 'v1.11.0'
otp-version: '22.3.4.2' otp-version: '22.3.4.2'
os: 'ubuntu-20.04' os: 'ubuntu-20.04'
@@ -84,16 +113,24 @@ jobs:
- elixir-version: 'master' - elixir-version: 'master'
otp-version: '23.1' otp-version: '23.1'
os: 'ubuntu-20.04' os: 'ubuntu-20.04'
- gleam-version: '0.16' - elixir-version: 'master'
otp-version: '25'
os: 'ubuntu-20.04'
version-type: 'strict'
- gleam-version: 'nightly'
otp-version: '24' otp-version: '24'
rebar3-version: '3.16' - gleam-version: '0.23'
os: 'ubuntu-latest'
- gleam-version: '0.19.0-rc3'
otp-version: '24' otp-version: '24'
os: 'ubuntu-latest' os: 'ubuntu-latest'
- gleam-version: '0.19.0-rc3' - gleam-version: '0.23.0-rc1'
otp-version: '24'
os: 'ubuntu-latest'
- gleam-version: '0.23.0-rc1'
otp-version: false otp-version: false
os: 'ubuntu-latest' os: 'ubuntu-latest'
- gleam-version: '0.22.0' # Version with Gleam's old archive naming convention
otp-version: '24'
os: 'ubuntu-latest'
steps: steps:
- uses: actions/checkout@v2 - uses: actions/checkout@v2
- name: Use erlef/setup-beam - name: Use erlef/setup-beam
@@ -134,11 +171,6 @@ jobs:
cd test-projects/erlang_rebar3 cd test-projects/erlang_rebar3
rebar3 ct rebar3 ct
if: ${{matrix.combo.rebar3-version}} if: ${{matrix.combo.rebar3-version}}
- name: Run Gleam/rebar3 project tests
run: |
cd test-projects/gleam_rebar3
rebar3 eunit
if: ${{matrix.combo.gleam-version}}
- name: Type check Gleam project (without installing Erlang/OTP) - name: Type check Gleam project (without installing Erlang/OTP)
run: | run: |
cd test-projects/gleam_gleam cd test-projects/gleam_gleam
@@ -149,3 +181,32 @@ jobs:
cd test-projects/gleam_gleam cd test-projects/gleam_gleam
gleam test gleam test
if: ${{ matrix.combo.gleam-version && matrix.combo.otp-version && !matrix.combo.rebar3-version }} if: ${{ matrix.combo.gleam-version && matrix.combo.otp-version && !matrix.combo.rebar3-version }}
environment_variables:
name: Environment variables
runs-on: ${{matrix.combo.os}}
strategy:
fail-fast: false
matrix:
combo:
- otp-version: '24'
elixir-version: 'v1.12'
gleam-version: '0.23.0-rc1'
rebar3-version: 'nightly'
os: 'ubuntu-latest'
steps:
- uses: actions/checkout@v2
- name: Use erlef/setup-beam
id: setup-beam
uses: ./
with:
otp-version: ${{matrix.combo.otp-version}}
elixir-version: ${{matrix.combo.elixir-version}}
gleam-version: ${{matrix.combo.gleam-version}}
rebar3-version: ${{matrix.combo.rebar3-version}}
- run: env
- name: List environment variables
run: |
echo "${{env.INSTALL_DIR_FOR_ELIXIR}}"
echo "${{env.INSTALL_DIR_FOR_GLEAM}}"
echo "${{env.INSTALL_DIR_FOR_OTP}}"
echo "${{env.INSTALL_DIR_FOR_REBAR3}}"
+19 -4
View File
@@ -4,10 +4,25 @@ set -eux
git config user.name "GitHub Actions" git config user.name "GitHub Actions"
git config user.email "actions@user.noreply.github.com" git config user.email "actions@user.noreply.github.com"
git checkout main
BRANCH=feature/3rd-party-licenses-update
if git branch -a | grep "$BRANCH" > /dev/null; then
# already exists
exit
fi
git fetch origin
git checkout -b "$BRANCH"
npm run licenses npm run licenses
git add 3RD_PARTY_LICENSES if ! git diff --exit-code 1> /dev/null ; then
git commit -m "Update 3rd party licenses" || true # there's stuff to push
git push origin git add 3RD_PARTY_LICENSES
git commit -m "Update 3rd party licenses"
git push origin "$BRANCH"
gh pr create --fill \
--title "Update 3rd party licenses (automation)" \
--body "This is an automated action to update the action's 3rd party licenses"
fi
@@ -17,3 +17,5 @@ jobs:
node-version: '14' node-version: '14'
- run: - run:
./.github/workflows/update_3rd_party_licenses.sh ./.github/workflows/update_3rd_party_licenses.sh
env:
GITHUB_TOKEN: ${{secrets.GITHUB_TOKEN}}
+32 -5
View File
@@ -21,6 +21,9 @@ jobs:
fail-fast: false fail-fast: false
matrix: matrix:
combo: combo:
- otp-version: '25'
rebar3-version: 'nightly'
os: 'windows-latest'
- otp-version: '24.0.2' - otp-version: '24.0.2'
rebar3-version: '3.16' rebar3-version: '3.16'
os: 'windows-2019' os: 'windows-2019'
@@ -38,7 +41,7 @@ jobs:
otp-version: '24' otp-version: '24'
rebar3-version: '3.15' rebar3-version: '3.15'
os: 'windows-latest' os: 'windows-latest'
- gleam-version: '0.16' - gleam-version: '0.23.0-rc1'
otp-version: '24' otp-version: '24'
rebar3-version: '3.16' rebar3-version: '3.16'
os: 'windows-latest' os: 'windows-latest'
@@ -79,8 +82,32 @@ jobs:
cd test-projects/erlang_rebar3 cd test-projects/erlang_rebar3
rebar3 ct rebar3 ct
if: ${{matrix.combo.rebar3-version}} if: ${{matrix.combo.rebar3-version}}
- name: Run Gleam/rebar3 project tests environment_variables:
name: Environment variables
runs-on: ${{matrix.combo.os}}
strategy:
fail-fast: false
matrix:
combo:
- otp-version: '24'
elixir-version: 'v1.12'
gleam-version: '0.23.0-rc1'
rebar3-version: 'nightly'
os: 'windows-latest'
steps:
- uses: actions/checkout@v2
- name: Use erlef/setup-beam
id: setup-beam
uses: ./
with:
otp-version: ${{matrix.combo.otp-version}}
elixir-version: ${{matrix.combo.elixir-version}}
gleam-version: ${{matrix.combo.gleam-version}}
rebar3-version: ${{matrix.combo.rebar3-version}}
- run: env
- name: List environment variables
run: | run: |
cd test-projects/gleam_rebar3 echo "${{env.INSTALL_DIR_FOR_ELIXIR}}"
rebar3 eunit echo "${{env.INSTALL_DIR_FOR_GLEAM}}"
if: ${{matrix.combo.gleam-version}} echo "${{env.INSTALL_DIR_FOR_OTP}}"
echo "${{env.INSTALL_DIR_FOR_REBAR3}}"
+6509 -810
View File
File diff suppressed because it is too large Load Diff
+1
View File
@@ -25,6 +25,7 @@ Here are a few things you can do that will increase the likelihood of your pull
- Write tests. - Write tests.
- Keep your change as focused as possible. If there are multiple changes you would like to make that are not dependent upon each other, consider submitting them as separate pull requests. - Keep your change as focused as possible. If there are multiple changes you would like to make that are not dependent upon each other, consider submitting them as separate pull requests.
- Write a [good commit message](http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html). - Write a [good commit message](http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html).
- Execute `npm run build-dist` and fix any issues arising from that
## Resources ## Resources
+21 -7
View File
@@ -18,7 +18,7 @@ workflow by:
- optionally, installing [`hex`](https://hex.pm/) - optionally, installing [`hex`](https://hex.pm/)
- optionally, having - optionally, having
[problem matchers](https://github.com/actions/toolkit/blob/main/docs/problem-matchers.md) show [problem matchers](https://github.com/actions/toolkit/blob/main/docs/problem-matchers.md) show
warnings and errors on pull requestsotp-version: false) warnings and errors on pull requests
**Note**: currently, this action only supports Actions' `ubuntu-` and `windows-` runtimes. **Note**: currently, this action only supports Actions' `ubuntu-` and `windows-` runtimes.
@@ -49,9 +49,11 @@ and Erlang/OTP.
| Operating system | Erlang/OTP | Status | Operating system | Erlang/OTP | Status
|- |- |- |- |- |-
| ubuntu-18.04 | 17 - 24 | ✅ | ubuntu-18.04 | 17 - 25 | ✅
| ubuntu-20.04 | 20 - 24 | ✅ | ubuntu-20.04 | 20 - 25 | ✅
| windows-2019 | 21* - 24 | ✅ | ubuntu-22.04 | 24.2 - 25 | ✅
| windows-2019 | 21* - 25 | ✅
| windows-2022 | 21* - 25 | ✅
**Note** *: prior to 23, Windows builds are only available for minor versions, e.g. 21.0, 21.3, 22.0, etc. **Note** *: prior to 23, Windows builds are only available for minor versions, e.g. 21.0, 21.3, 22.0, etc.
@@ -64,7 +66,9 @@ uses that to download assets:
|- |- |- |-
| ubuntu18 | ubuntu-18.04 | ubuntu18 | ubuntu-18.04
| ubuntu20 | ubuntu-20.04 | ubuntu20 | ubuntu-20.04
| ubuntu22 | ubuntu-22.04
| win19 | windows-2019 | win19 | windows-2019
| win22 | windows-2022
as per the following example: as per the following example:
@@ -137,7 +141,7 @@ on: push
jobs: jobs:
test: test:
runs-on: windows-2019 runs-on: windows-2022
steps: steps:
- uses: actions/checkout@v2 - uses: actions/checkout@v2
- uses: erlef/setup-beam@v1 - uses: erlef/setup-beam@v1
@@ -161,7 +165,7 @@ jobs:
- uses: erlef/setup-beam@v1 - uses: erlef/setup-beam@v1
with: with:
otp-version: '24' otp-version: '24'
gleam-version: '0.19.0-rc3' gleam-version: '0.23.0-rc1'
- run: gleam test - run: gleam test
``` ```
@@ -179,12 +183,22 @@ jobs:
- uses: erlef/setup-beam@v1 - uses: erlef/setup-beam@v1
with: with:
otp-version: false otp-version: false
gleam-version: '0.19.0-rc3' gleam-version: '0.23.0-rc1'
- run: gleam check - run: gleam check
``` ```
**Note**: the `otp-version: false` input is only applicable when installing Gleam. **Note**: the `otp-version: false` input is only applicable when installing Gleam.
## Environment variables
Base installation folders (useful for e.g. fetching headers for NIFs) are available in the following
environment variables:
- `INSTALL_DIR_FOR_OTP`: base folder for Erlang/OTP
- `INSTALL_DIR_FOR_ELIXIR`: base folder for Elixir
- `INSTALL_DIR_FOR_GLEAM`: base folder for Gleam
- `INSTALL_DIR_FOR_REBAR3`: base folder for `rebar3`
## Elixir Problem Matchers ## Elixir Problem Matchers
The Elixir Problem Matchers in this repository are adapted from The Elixir Problem Matchers in this repository are adapted from
+2 -2
View File
@@ -171,8 +171,8 @@ async function testElixirVersions() {
let otpVersion let otpVersion
spec = '1.1.x' spec = '1.1.x'
otpVersion = 'OTP-23' otpVersion = 'OTP-17'
expected = 'v1.1.1' expected = 'v1.1.1-otp-17'
got = await setupBeam.getElixirVersion(spec, otpVersion) got = await setupBeam.getElixirVersion(spec, otpVersion)
assert.deepStrictEqual(got, expected) assert.deepStrictEqual(got, expected)
+1 -1
View File
@@ -43,5 +43,5 @@ outputs:
rebar3-version: rebar3-version:
description: Exact version of rebar3 that was installed description: Exact version of rebar3 that was installed
runs: runs:
using: node12 using: node16
main: dist/index.js main: dist/index.js
+3491 -941
View File
File diff suppressed because it is too large Load Diff
+7 -5
View File
@@ -1,19 +1,21 @@
param([Parameter(Mandatory=$true)][string]$VSN) param([Parameter(Mandatory=$true)][string]${VSN})
$ErrorActionPreference="Stop" $ErrorActionPreference="Stop"
Set-Location $Env:RUNNER_TEMP Set-Location ${Env:RUNNER_TEMP}
$FILE_INPUT="${VSN}.zip" $FILE_INPUT="${VSN}.zip"
$FILE_OUTPUT="elixir.zip" $FILE_OUTPUT="elixir.zip"
$DIR_FOR_BIN=".setup-beam/elixir" $DIR_FOR_BIN=".setup-beam/elixir"
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Invoke-WebRequest "https://repo.hex.pm/builds/elixir/${FILE_INPUT}" -OutFile "$FILE_OUTPUT" Invoke-WebRequest "https://repo.hex.pm/builds/elixir/${FILE_INPUT}" -OutFile "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
New-Item "$DIR_FOR_BIN" -ItemType Directory | Out-Null New-Item "${DIR_FOR_BIN}" -ItemType Directory | Out-Null
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Expand-Archive -DestinationPath "${DIR_FOR_BIN}" -Path "${FILE_OUTPUT}" Expand-Archive -DestinationPath "${DIR_FOR_BIN}" -Path "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
Write-Output "Installed Elixir version follows" Write-Output "Installed Elixir version follows"
& "$DIR_FOR_BIN/bin/elixir" "-v" | Write-Output & "${DIR_FOR_BIN}/bin/elixir" "-v" | Write-Output
"INSTALL_DIR_FOR_ELIXIR=${Env:RUNNER_TEMP}/${DIR_FOR_BIN}" | Out-File -FilePath ${Env:GITHUB_ENV} -Encoding utf8 -Append
+4 -2
View File
@@ -2,7 +2,7 @@
set -eo pipefail set -eo pipefail
cd "$RUNNER_TEMP" cd "${RUNNER_TEMP}"
VSN=${1} VSN=${1}
FILE_INPUT="${VSN}.zip" FILE_INPUT="${VSN}.zip"
@@ -11,6 +11,8 @@ DIR_FOR_BIN=.setup-beam/elixir
wget -q -O "${FILE_OUTPUT}" "https://repo.hex.pm/builds/elixir/${FILE_INPUT}" wget -q -O "${FILE_OUTPUT}" "https://repo.hex.pm/builds/elixir/${FILE_INPUT}"
mkdir -p "${DIR_FOR_BIN}" mkdir -p "${DIR_FOR_BIN}"
unzip -q -d "${DIR_FOR_BIN}" "${FILE_OUTPUT}" unzip -q -o -d "${DIR_FOR_BIN}" "${FILE_OUTPUT}"
echo "Installed Elixir version follows" echo "Installed Elixir version follows"
${DIR_FOR_BIN}/bin/elixir -v ${DIR_FOR_BIN}/bin/elixir -v
echo "INSTALL_DIR_FOR_ELIXIR=${RUNNER_TEMP}/${DIR_FOR_BIN}" >> "${GITHUB_ENV}"
+10 -8
View File
@@ -1,19 +1,21 @@
param([Parameter(Mandatory=$true)][string]$VSN) param([Parameter(Mandatory=$true)][string]${VSN})
$ErrorActionPreference="Stop" $ErrorActionPreference="Stop"
Set-Location $Env:RUNNER_TEMP Set-Location ${Env:RUNNER_TEMP}
$FILE_INPUT="gleam-${VSN}-windows-64bit.zip" $FILE_INPUT="gleam-${VSN}-x86_64-pc-windows-msvc.zip"
$FILE_OUTPUT="gleam.zip" $FILE_OUTPUT="gleam.zip"
$DIR_FOR_BIN=".setup-beam/gleam/bin" $DIR_FOR_BIN=".setup-beam/gleam"
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Invoke-WebRequest "https://github.com/gleam-lang/gleam/releases/download/${VSN}/${FILE_INPUT}" -OutFile "$FILE_OUTPUT" Invoke-WebRequest "https://github.com/gleam-lang/gleam/releases/download/${VSN}/${FILE_INPUT}" -OutFile "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
New-Item "$DIR_FOR_BIN" -ItemType Directory | Out-Null New-Item "${DIR_FOR_BIN}/bin" -ItemType Directory | Out-Null
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Expand-Archive -DestinationPath "${DIR_FOR_BIN}" -Path "${FILE_OUTPUT}" Expand-Archive -DestinationPath "${DIR_FOR_BIN}/bin" -Path "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
Write-Output "Installed Gleam version follows" Write-Output "Installed Gleam version follows"
& "$DIR_FOR_BIN/gleam" "--version" | Write-Output & "${DIR_FOR_BIN}/bin/gleam" "--version" | Write-Output
"INSTALL_DIR_FOR_GLEAM=${Env:RUNNER_TEMP}/${DIR_FOR_BIN}" | Out-File -FilePath ${Env:GITHUB_ENV} -Encoding utf8 -Append
+24 -7
View File
@@ -2,16 +2,33 @@
set -eo pipefail set -eo pipefail
cd "$RUNNER_TEMP" cd "${RUNNER_TEMP}"
VSN=${1} VSN="$1"
FILE_INPUT=gleam-${VSN}-linux-amd64.tar.gz
FILE_OUTPUT=gleam.tar.gz FILE_OUTPUT=gleam.tar.gz
DIR_FOR_BIN=.setup-beam/gleam/bin DIR_FOR_BIN=.setup-beam/gleam
version_gt() {
test "$(printf '%s\n' "$@" | sort -V | head -n 1)" != "$1"
}
uses_llvm_triplets() {
local version="$1"
test "$version" = "nightly" || version_gt "$version" "v0.22.1"
}
if uses_llvm_triplets "$VSN"
then
FILE_INPUT="gleam-${VSN}-x86_64-unknown-linux-musl.tar.gz"
else
FILE_INPUT="gleam-${VSN}-linux-amd64.tar.gz"
fi
wget -q -O "${FILE_OUTPUT}" "https://github.com/gleam-lang/gleam/releases/download/${VSN}/${FILE_INPUT}" wget -q -O "${FILE_OUTPUT}" "https://github.com/gleam-lang/gleam/releases/download/${VSN}/${FILE_INPUT}"
mkdir -p "${DIR_FOR_BIN}" mkdir -p "${DIR_FOR_BIN}/bin"
tar zxf "${FILE_OUTPUT}" -C "${DIR_FOR_BIN}" tar zxf "${FILE_OUTPUT}" -C "${DIR_FOR_BIN}/bin"
echo "Installed Gleam version follows" echo "Installed Gleam version follows"
${DIR_FOR_BIN}/gleam --version ${DIR_FOR_BIN}/bin/gleam --version
echo "INSTALL_DIR_FOR_GLEAM=${RUNNER_TEMP}/${DIR_FOR_BIN}" >> "${GITHUB_ENV}"
+8 -11
View File
@@ -1,20 +1,17 @@
param([Parameter(Mandatory=$true)][string]$VSN) param([Parameter(Mandatory=$true)][string]${VSN})
$ErrorActionPreference="Stop" $ErrorActionPreference="Stop"
Set-Location $Env:RUNNER_TEMP Set-Location ${Env:RUNNER_TEMP}
$FILE_OUTPUT="otp.exe" $FILE_OUTPUT="otp.exe"
$DIR_FOR_BIN=".setup-beam/otp" $ERL_ROOT = "${Env:RUNNER_TEMP}\.setup-beam\otp"
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Invoke-WebRequest "https://github.com/erlang/otp/releases/download/OTP-$VSN/otp_win64_$VSN.exe" -OutFile "$FILE_OUTPUT" Invoke-WebRequest "https://github.com/erlang/otp/releases/download/OTP-${VSN}/otp_win64_${VSN}.exe" -OutFile "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
New-Item "$DIR_FOR_BIN" -ItemType Directory | Out-Null Start-Process "${FILE_OUTPUT}" "/S /D=${ERL_ROOT}" -Wait
Move-Item "$FILE_OUTPUT" "$DIR_FOR_BIN"
Start-Process "./$DIR_FOR_BIN/$FILE_OUTPUT" /S -Wait
$ErlExec = Get-ChildItem -Path "C:/Program Files/" -Recurse -Depth 2 -Filter 'erl.exe' -Name | ForEach-Object { Write-Output "C:/Program Files/$_" }
$ErlPath = Split-Path -Path "$ErlExec"
Write-Output "$ErlPath" | Out-File -FilePath otp_path.txt -Encoding utf8 -NoNewline
Write-Output "Installed Erlang/OTP version follows" Write-Output "Installed Erlang/OTP version follows"
& "$ErlPath/erl.exe" "+V" | Write-Output & "${ERL_ROOT}/bin/erl.exe" "+V" | Write-Output
"INSTALL_DIR_FOR_OTP=${ERL_ROOT}" | Out-File -FilePath ${Env:GITHUB_ENV} -Encoding utf8 -Append
+3 -1
View File
@@ -2,7 +2,7 @@
set -eo pipefail set -eo pipefail
cd "$RUNNER_TEMP" cd "${RUNNER_TEMP}"
OS=${1} OS=${1}
VSN=${2} VSN=${2}
@@ -16,3 +16,5 @@ tar zxf "${FILE_OUTPUT}" -C "${DIR_FOR_BIN}" --strip-components=1
"${DIR_FOR_BIN}/Install" -minimal "$(pwd)/${DIR_FOR_BIN}" "${DIR_FOR_BIN}/Install" -minimal "$(pwd)/${DIR_FOR_BIN}"
echo "Installed Erlang/OTP version follows" echo "Installed Erlang/OTP version follows"
${DIR_FOR_BIN}/bin/erl -version ${DIR_FOR_BIN}/bin/erl -version
echo "INSTALL_DIR_FOR_OTP=${RUNNER_TEMP}/${DIR_FOR_BIN}" >> "${GITHUB_ENV}"
+13 -11
View File
@@ -1,8 +1,8 @@
param([Parameter(Mandatory=$true)][string]$VSN) param([Parameter(Mandatory=$true)][string]${VSN})
$ErrorActionPreference="Stop" $ErrorActionPreference="Stop"
Set-Location $Env:RUNNER_TEMP Set-Location ${Env:RUNNER_TEMP}
$FILE_INPUT="rebar3" $FILE_INPUT="rebar3"
$FILE_OUTPUT="rebar3" $FILE_OUTPUT="rebar3"
@@ -12,17 +12,19 @@ $DIR_FOR_BIN=".setup-beam/rebar3"
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
$REBAR3_TARGET="https://github.com/erlang/rebar3/releases/download/${VSN}/${FILE_INPUT}" $REBAR3_TARGET="https://github.com/erlang/rebar3/releases/download/${VSN}/${FILE_INPUT}"
$REBAR3_NIGHTLY="" $REBAR3_NIGHTLY=""
If ( $VSN -eq "nightly" ) If ( ${VSN} -eq "nightly" )
{ {
$REBAR3_TARGET="https://s3.amazonaws.com/rebar3-nightly/rebar3" $REBAR3_TARGET="https://s3.amazonaws.com/rebar3-nightly/rebar3"
$REBAR3_NIGHTLY=" (from nightly build)" $REBAR3_NIGHTLY=" (from nightly build)"
} }
Invoke-WebRequest "$REBAR3_TARGET" -OutFile "$FILE_OUTPUT" Invoke-WebRequest "${REBAR3_TARGET}" -OutFile "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
New-Item "$DIR_FOR_BIN/bin" -ItemType Directory | Out-Null New-Item "${DIR_FOR_BIN}/bin" -ItemType Directory | Out-Null
Move-Item "$FILE_OUTPUT" "$DIR_FOR_BIN/bin" Move-Item "${FILE_OUTPUT}" "${DIR_FOR_BIN}/bin"
Write-Output "& escript.exe $PWD/$DIR_FOR_BIN/bin/$FILE_OUTPUT `$args" | Out-File -FilePath "$FILE_OUTPUT_PS1" -Encoding utf8 -Append Write-Output "& escript.exe ${PWD}/${DIR_FOR_BIN}/bin/${FILE_OUTPUT} `${args}" | Out-File -FilePath "${FILE_OUTPUT_PS1}" -Encoding utf8 -Append
type $FILE_OUTPUT_PS1 type ${FILE_OUTPUT_PS1}
Move-Item "$FILE_OUTPUT_PS1" "$DIR_FOR_BIN/bin" Move-Item "${FILE_OUTPUT_PS1}" "${DIR_FOR_BIN}/bin"
Write-Output "Installed rebar3 version$REBAR3_NIGHTLY follows" Write-Output "Installed rebar3 version${REBAR3_NIGHTLY} follows"
& "$DIR_FOR_BIN/bin/rebar3" "version" | Write-Output & "${DIR_FOR_BIN}/bin/rebar3" "version" | Write-Output
"INSTALL_DIR_FOR_REBAR3=${Env:RUNNER_TEMP}/${DIR_FOR_BIN}" | Out-File -FilePath ${Env:GITHUB_ENV} -Encoding utf8 -Append
+4 -2
View File
@@ -2,7 +2,7 @@
set -eo pipefail set -eo pipefail
cd "$RUNNER_TEMP" cd "${RUNNER_TEMP}"
VSN=${1} VSN=${1}
FILE_INPUT=rebar3 FILE_INPUT=rebar3
@@ -19,5 +19,7 @@ wget -q -O "${FILE_OUTPUT}" "${REBAR3_TARGET}"
mkdir -p "${DIR_FOR_BIN}/bin" mkdir -p "${DIR_FOR_BIN}/bin"
chmod +x "${FILE_OUTPUT}" chmod +x "${FILE_OUTPUT}"
mv "${FILE_OUTPUT}" "${DIR_FOR_BIN}/bin" mv "${FILE_OUTPUT}" "${DIR_FOR_BIN}/bin"
echo "Installed rebar3 version$REBAR3_NIGHTLY follows" echo "Installed rebar3 version${REBAR3_NIGHTLY} follows"
${DIR_FOR_BIN}/bin/rebar3 version ${DIR_FOR_BIN}/bin/rebar3 version
echo "INSTALL_DIR_FOR_REBAR3=${RUNNER_TEMP}/${DIR_FOR_BIN}" >> "${GITHUB_ENV}"
-82
View File
@@ -1,82 +0,0 @@
@actions/core
MIT
The MIT License (MIT)
Copyright 2019 GitHub
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
@actions/exec
MIT
@actions/io
MIT
The MIT License (MIT)
Copyright 2019 GitHub
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
lru-cache
ISC
The ISC License
Copyright (c) Isaac Z. Schlueter and Contributors
Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.
THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
semver
ISC
The ISC License
Copyright (c) Isaac Z. Schlueter and Contributors
Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.
THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
yallist
ISC
The ISC License
Copyright (c) Isaac Z. Schlueter and Contributors
Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.
THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+1896 -2321
View File
File diff suppressed because it is too large Load Diff
+19 -18
View File
@@ -3,14 +3,15 @@
"license": "MIT", "license": "MIT",
"private": true, "private": true,
"scripts": { "scripts": {
"build": "ncc build src/setup-beam.js --no-cache --license licenses.txt", "build": "ncc build src/setup-beam.js --no-cache",
"format": "prettier src/**/*.js --write && prettier __tests__/**/*.js --write", "format": "prettier src/**/*.js --write && prettier __tests__/**/*.js --write",
"jslint": "eslint src/**/*.js && eslint __tests__/**/*.js", "jslint": "eslint src/**/*.js && eslint __tests__/**/*.js",
"licenses": "yarn licenses generate-disclaimer > 3RD_PARTY_LICENSES", "licenses": "yarn licenses generate-disclaimer > 3RD_PARTY_LICENSES",
"markdownlint": "markdownlint *.md", "markdownlint": "markdownlint *.md",
"shellcheck": "shellcheck src/install-*.sh .github/workflows/*.sh", "shellcheck": "shellcheck src/install-*.sh .github/workflows/*.sh",
"test": "node __tests__/setup-beam.test.js && node ./__tests__/problem-matchers.test.js", "test": "node __tests__/setup-beam.test.js && node ./__tests__/problem-matchers.test.js",
"yamllint": "yamllint .github/workflows/**.yml && yamllint .*.yml && yamllint *.yml" "yamllint": "yamllint .github/workflows/**.yml && yamllint .*.yml && yamllint *.yml",
"build-dist": "npm install && npm run build && npm run format && npm run markdownlint && npm run shellcheck && npm run yamllint && npm run jslint"
}, },
"husky": { "husky": {
"hooks": { "hooks": {
@@ -18,25 +19,25 @@
} }
}, },
"dependencies": { "dependencies": {
"@actions/core": "1.2.6", "@actions/core": "1.9.1",
"@actions/exec": "1.0.4", "@actions/exec": "1.1.1",
"semver": "7.3.4" "semver": "7.3.6"
}, },
"devDependencies": { "devDependencies": {
"@vercel/ncc": "0.27.0", "@vercel/ncc": "0.33.4",
"eslint": "7.22.0", "eslint": "8.14.0",
"eslint-config-airbnb": "v18.2.1", "eslint-config-airbnb": "19.0.4",
"eslint-plugin-import": "^2.24.2", "eslint-plugin-import": "2.26.0",
"eslint-plugin-jsx-a11y": "^6.4.1", "eslint-plugin-jsx-a11y": "6.5.1",
"eslint-plugin-react": "^7.25.1", "eslint-plugin-react": "7.29.0",
"husky": "5.2.0", "husky": "7.0.4",
"markdownlint": "0.23.1", "markdownlint": "0.25.1",
"prettier": "2.2.1", "prettier": "2.6.2",
"shellcheck": "1.0.0", "shellcheck": "1.1.0",
"yaml-lint": "1.2.4", "yaml-lint": "1.3.0",
"yarn": "1.22.10" "yarn": "1.22.18"
}, },
"engines": { "engines": {
"node": ">=12" "node": ">=16"
} }
} }
+7 -5
View File
@@ -1,19 +1,21 @@
param([Parameter(Mandatory=$true)][string]$VSN) param([Parameter(Mandatory=$true)][string]${VSN})
$ErrorActionPreference="Stop" $ErrorActionPreference="Stop"
Set-Location $Env:RUNNER_TEMP Set-Location ${Env:RUNNER_TEMP}
$FILE_INPUT="${VSN}.zip" $FILE_INPUT="${VSN}.zip"
$FILE_OUTPUT="elixir.zip" $FILE_OUTPUT="elixir.zip"
$DIR_FOR_BIN=".setup-beam/elixir" $DIR_FOR_BIN=".setup-beam/elixir"
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Invoke-WebRequest "https://repo.hex.pm/builds/elixir/${FILE_INPUT}" -OutFile "$FILE_OUTPUT" Invoke-WebRequest "https://repo.hex.pm/builds/elixir/${FILE_INPUT}" -OutFile "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
New-Item "$DIR_FOR_BIN" -ItemType Directory | Out-Null New-Item "${DIR_FOR_BIN}" -ItemType Directory | Out-Null
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Expand-Archive -DestinationPath "${DIR_FOR_BIN}" -Path "${FILE_OUTPUT}" Expand-Archive -DestinationPath "${DIR_FOR_BIN}" -Path "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
Write-Output "Installed Elixir version follows" Write-Output "Installed Elixir version follows"
& "$DIR_FOR_BIN/bin/elixir" "-v" | Write-Output & "${DIR_FOR_BIN}/bin/elixir" "-v" | Write-Output
"INSTALL_DIR_FOR_ELIXIR=${Env:RUNNER_TEMP}/${DIR_FOR_BIN}" | Out-File -FilePath ${Env:GITHUB_ENV} -Encoding utf8 -Append
+4 -2
View File
@@ -2,7 +2,7 @@
set -eo pipefail set -eo pipefail
cd "$RUNNER_TEMP" cd "${RUNNER_TEMP}"
VSN=${1} VSN=${1}
FILE_INPUT="${VSN}.zip" FILE_INPUT="${VSN}.zip"
@@ -11,6 +11,8 @@ DIR_FOR_BIN=.setup-beam/elixir
wget -q -O "${FILE_OUTPUT}" "https://repo.hex.pm/builds/elixir/${FILE_INPUT}" wget -q -O "${FILE_OUTPUT}" "https://repo.hex.pm/builds/elixir/${FILE_INPUT}"
mkdir -p "${DIR_FOR_BIN}" mkdir -p "${DIR_FOR_BIN}"
unzip -q -d "${DIR_FOR_BIN}" "${FILE_OUTPUT}" unzip -q -o -d "${DIR_FOR_BIN}" "${FILE_OUTPUT}"
echo "Installed Elixir version follows" echo "Installed Elixir version follows"
${DIR_FOR_BIN}/bin/elixir -v ${DIR_FOR_BIN}/bin/elixir -v
echo "INSTALL_DIR_FOR_ELIXIR=${RUNNER_TEMP}/${DIR_FOR_BIN}" >> "${GITHUB_ENV}"
+10 -8
View File
@@ -1,19 +1,21 @@
param([Parameter(Mandatory=$true)][string]$VSN) param([Parameter(Mandatory=$true)][string]${VSN})
$ErrorActionPreference="Stop" $ErrorActionPreference="Stop"
Set-Location $Env:RUNNER_TEMP Set-Location ${Env:RUNNER_TEMP}
$FILE_INPUT="gleam-${VSN}-windows-64bit.zip" $FILE_INPUT="gleam-${VSN}-x86_64-pc-windows-msvc.zip"
$FILE_OUTPUT="gleam.zip" $FILE_OUTPUT="gleam.zip"
$DIR_FOR_BIN=".setup-beam/gleam/bin" $DIR_FOR_BIN=".setup-beam/gleam"
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Invoke-WebRequest "https://github.com/gleam-lang/gleam/releases/download/${VSN}/${FILE_INPUT}" -OutFile "$FILE_OUTPUT" Invoke-WebRequest "https://github.com/gleam-lang/gleam/releases/download/${VSN}/${FILE_INPUT}" -OutFile "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
New-Item "$DIR_FOR_BIN" -ItemType Directory | Out-Null New-Item "${DIR_FOR_BIN}/bin" -ItemType Directory | Out-Null
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Expand-Archive -DestinationPath "${DIR_FOR_BIN}" -Path "${FILE_OUTPUT}" Expand-Archive -DestinationPath "${DIR_FOR_BIN}/bin" -Path "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
Write-Output "Installed Gleam version follows" Write-Output "Installed Gleam version follows"
& "$DIR_FOR_BIN/gleam" "--version" | Write-Output & "${DIR_FOR_BIN}/bin/gleam" "--version" | Write-Output
"INSTALL_DIR_FOR_GLEAM=${Env:RUNNER_TEMP}/${DIR_FOR_BIN}" | Out-File -FilePath ${Env:GITHUB_ENV} -Encoding utf8 -Append
+24 -7
View File
@@ -2,16 +2,33 @@
set -eo pipefail set -eo pipefail
cd "$RUNNER_TEMP" cd "${RUNNER_TEMP}"
VSN=${1} VSN="$1"
FILE_INPUT=gleam-${VSN}-linux-amd64.tar.gz
FILE_OUTPUT=gleam.tar.gz FILE_OUTPUT=gleam.tar.gz
DIR_FOR_BIN=.setup-beam/gleam/bin DIR_FOR_BIN=.setup-beam/gleam
version_gt() {
test "$(printf '%s\n' "$@" | sort -V | head -n 1)" != "$1"
}
uses_llvm_triplets() {
local version="$1"
test "$version" = "nightly" || version_gt "$version" "v0.22.1"
}
if uses_llvm_triplets "$VSN"
then
FILE_INPUT="gleam-${VSN}-x86_64-unknown-linux-musl.tar.gz"
else
FILE_INPUT="gleam-${VSN}-linux-amd64.tar.gz"
fi
wget -q -O "${FILE_OUTPUT}" "https://github.com/gleam-lang/gleam/releases/download/${VSN}/${FILE_INPUT}" wget -q -O "${FILE_OUTPUT}" "https://github.com/gleam-lang/gleam/releases/download/${VSN}/${FILE_INPUT}"
mkdir -p "${DIR_FOR_BIN}" mkdir -p "${DIR_FOR_BIN}/bin"
tar zxf "${FILE_OUTPUT}" -C "${DIR_FOR_BIN}" tar zxf "${FILE_OUTPUT}" -C "${DIR_FOR_BIN}/bin"
echo "Installed Gleam version follows" echo "Installed Gleam version follows"
${DIR_FOR_BIN}/gleam --version ${DIR_FOR_BIN}/bin/gleam --version
echo "INSTALL_DIR_FOR_GLEAM=${RUNNER_TEMP}/${DIR_FOR_BIN}" >> "${GITHUB_ENV}"
+8 -11
View File
@@ -1,20 +1,17 @@
param([Parameter(Mandatory=$true)][string]$VSN) param([Parameter(Mandatory=$true)][string]${VSN})
$ErrorActionPreference="Stop" $ErrorActionPreference="Stop"
Set-Location $Env:RUNNER_TEMP Set-Location ${Env:RUNNER_TEMP}
$FILE_OUTPUT="otp.exe" $FILE_OUTPUT="otp.exe"
$DIR_FOR_BIN=".setup-beam/otp" $ERL_ROOT = "${Env:RUNNER_TEMP}\.setup-beam\otp"
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
Invoke-WebRequest "https://github.com/erlang/otp/releases/download/OTP-$VSN/otp_win64_$VSN.exe" -OutFile "$FILE_OUTPUT" Invoke-WebRequest "https://github.com/erlang/otp/releases/download/OTP-${VSN}/otp_win64_${VSN}.exe" -OutFile "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
New-Item "$DIR_FOR_BIN" -ItemType Directory | Out-Null Start-Process "${FILE_OUTPUT}" "/S /D=${ERL_ROOT}" -Wait
Move-Item "$FILE_OUTPUT" "$DIR_FOR_BIN"
Start-Process "./$DIR_FOR_BIN/$FILE_OUTPUT" /S -Wait
$ErlExec = Get-ChildItem -Path "C:/Program Files/" -Recurse -Depth 2 -Filter 'erl.exe' -Name | ForEach-Object { Write-Output "C:/Program Files/$_" }
$ErlPath = Split-Path -Path "$ErlExec"
Write-Output "$ErlPath" | Out-File -FilePath otp_path.txt -Encoding utf8 -NoNewline
Write-Output "Installed Erlang/OTP version follows" Write-Output "Installed Erlang/OTP version follows"
& "$ErlPath/erl.exe" "+V" | Write-Output & "${ERL_ROOT}/bin/erl.exe" "+V" | Write-Output
"INSTALL_DIR_FOR_OTP=${ERL_ROOT}" | Out-File -FilePath ${Env:GITHUB_ENV} -Encoding utf8 -Append
+3 -1
View File
@@ -2,7 +2,7 @@
set -eo pipefail set -eo pipefail
cd "$RUNNER_TEMP" cd "${RUNNER_TEMP}"
OS=${1} OS=${1}
VSN=${2} VSN=${2}
@@ -16,3 +16,5 @@ tar zxf "${FILE_OUTPUT}" -C "${DIR_FOR_BIN}" --strip-components=1
"${DIR_FOR_BIN}/Install" -minimal "$(pwd)/${DIR_FOR_BIN}" "${DIR_FOR_BIN}/Install" -minimal "$(pwd)/${DIR_FOR_BIN}"
echo "Installed Erlang/OTP version follows" echo "Installed Erlang/OTP version follows"
${DIR_FOR_BIN}/bin/erl -version ${DIR_FOR_BIN}/bin/erl -version
echo "INSTALL_DIR_FOR_OTP=${RUNNER_TEMP}/${DIR_FOR_BIN}" >> "${GITHUB_ENV}"
+13 -11
View File
@@ -1,8 +1,8 @@
param([Parameter(Mandatory=$true)][string]$VSN) param([Parameter(Mandatory=$true)][string]${VSN})
$ErrorActionPreference="Stop" $ErrorActionPreference="Stop"
Set-Location $Env:RUNNER_TEMP Set-Location ${Env:RUNNER_TEMP}
$FILE_INPUT="rebar3" $FILE_INPUT="rebar3"
$FILE_OUTPUT="rebar3" $FILE_OUTPUT="rebar3"
@@ -12,17 +12,19 @@ $DIR_FOR_BIN=".setup-beam/rebar3"
$ProgressPreference="SilentlyContinue" $ProgressPreference="SilentlyContinue"
$REBAR3_TARGET="https://github.com/erlang/rebar3/releases/download/${VSN}/${FILE_INPUT}" $REBAR3_TARGET="https://github.com/erlang/rebar3/releases/download/${VSN}/${FILE_INPUT}"
$REBAR3_NIGHTLY="" $REBAR3_NIGHTLY=""
If ( $VSN -eq "nightly" ) If ( ${VSN} -eq "nightly" )
{ {
$REBAR3_TARGET="https://s3.amazonaws.com/rebar3-nightly/rebar3" $REBAR3_TARGET="https://s3.amazonaws.com/rebar3-nightly/rebar3"
$REBAR3_NIGHTLY=" (from nightly build)" $REBAR3_NIGHTLY=" (from nightly build)"
} }
Invoke-WebRequest "$REBAR3_TARGET" -OutFile "$FILE_OUTPUT" Invoke-WebRequest "${REBAR3_TARGET}" -OutFile "${FILE_OUTPUT}"
$ProgressPreference="Continue" $ProgressPreference="Continue"
New-Item "$DIR_FOR_BIN/bin" -ItemType Directory | Out-Null New-Item "${DIR_FOR_BIN}/bin" -ItemType Directory | Out-Null
Move-Item "$FILE_OUTPUT" "$DIR_FOR_BIN/bin" Move-Item "${FILE_OUTPUT}" "${DIR_FOR_BIN}/bin"
Write-Output "& escript.exe $PWD/$DIR_FOR_BIN/bin/$FILE_OUTPUT `$args" | Out-File -FilePath "$FILE_OUTPUT_PS1" -Encoding utf8 -Append Write-Output "& escript.exe ${PWD}/${DIR_FOR_BIN}/bin/${FILE_OUTPUT} `${args}" | Out-File -FilePath "${FILE_OUTPUT_PS1}" -Encoding utf8 -Append
type $FILE_OUTPUT_PS1 type ${FILE_OUTPUT_PS1}
Move-Item "$FILE_OUTPUT_PS1" "$DIR_FOR_BIN/bin" Move-Item "${FILE_OUTPUT_PS1}" "${DIR_FOR_BIN}/bin"
Write-Output "Installed rebar3 version$REBAR3_NIGHTLY follows" Write-Output "Installed rebar3 version${REBAR3_NIGHTLY} follows"
& "$DIR_FOR_BIN/bin/rebar3" "version" | Write-Output & "${DIR_FOR_BIN}/bin/rebar3" "version" | Write-Output
"INSTALL_DIR_FOR_REBAR3=${Env:RUNNER_TEMP}/${DIR_FOR_BIN}" | Out-File -FilePath ${Env:GITHUB_ENV} -Encoding utf8 -Append
+4 -2
View File
@@ -2,7 +2,7 @@
set -eo pipefail set -eo pipefail
cd "$RUNNER_TEMP" cd "${RUNNER_TEMP}"
VSN=${1} VSN=${1}
FILE_INPUT=rebar3 FILE_INPUT=rebar3
@@ -19,5 +19,7 @@ wget -q -O "${FILE_OUTPUT}" "${REBAR3_TARGET}"
mkdir -p "${DIR_FOR_BIN}/bin" mkdir -p "${DIR_FOR_BIN}/bin"
chmod +x "${FILE_OUTPUT}" chmod +x "${FILE_OUTPUT}"
mv "${FILE_OUTPUT}" "${DIR_FOR_BIN}/bin" mv "${FILE_OUTPUT}" "${DIR_FOR_BIN}/bin"
echo "Installed rebar3 version$REBAR3_NIGHTLY follows" echo "Installed rebar3 version${REBAR3_NIGHTLY} follows"
${DIR_FOR_BIN}/bin/rebar3 version ${DIR_FOR_BIN}/bin/rebar3 version
echo "INSTALL_DIR_FOR_REBAR3=${RUNNER_TEMP}/${DIR_FOR_BIN}" >> "${GITHUB_ENV}"
+26 -28
View File
@@ -3,7 +3,6 @@ const { exec } = require('@actions/exec')
const path = require('path') const path = require('path')
const semver = require('semver') const semver = require('semver')
const https = require('https') const https = require('https')
const fs = require('fs')
const installer = require('./installer') const installer = require('./installer')
main().catch((err) => { main().catch((err) => {
@@ -48,15 +47,7 @@ async function installOTP(otpSpec, osVersion) {
) )
await installer.installOTP(osVersion, otpVersion) await installer.installOTP(osVersion, otpVersion)
core.setOutput('otp-version', otpVersion) core.setOutput('otp-version', otpVersion)
if (process.platform === 'linux') { core.addPath(`${process.env.RUNNER_TEMP}/.setup-beam/otp/bin`)
core.addPath(`${process.env.RUNNER_TEMP}/.setup-beam/otp/bin`)
} else if (process.platform === 'win32') {
const otpPath = fs.readFileSync(`${process.env.RUNNER_TEMP}/otp_path.txt`, {
encoding: 'utf8',
flag: 'r',
})
core.addPath(otpPath)
}
console.log('##[endgroup]') console.log('##[endgroup]')
return otpVersion return otpVersion
@@ -73,7 +64,7 @@ async function maybeInstallElixir(elixirSpec, otpVersion) {
const disableProblemMatchers = core.getInput('disable_problem_matchers', { const disableProblemMatchers = core.getInput('disable_problem_matchers', {
required: false, required: false,
}) })
if (!disableProblemMatchers) { if (disableProblemMatchers === 'false') {
const matchersPath = path.join(__dirname, '..', '.github') const matchersPath = path.join(__dirname, '..', '.github')
console.log( console.log(
`##[add-matcher]${path.join(matchersPath, 'elixir-matchers.json')}`, `##[add-matcher]${path.join(matchersPath, 'elixir-matchers.json')}`,
@@ -89,7 +80,7 @@ async function maybeInstallElixir(elixirSpec, otpVersion) {
} }
async function mix(shouldMix, what) { async function mix(shouldMix, what) {
if (shouldMix) { if (shouldMix === 'true') {
const cmd = 'mix' const cmd = 'mix'
const args = [`local.${what}`, '--force'] const args = [`local.${what}`, '--force']
console.log(`##[group]Running ${cmd} ${args}`) console.log(`##[group]Running ${cmd} ${args}`)
@@ -139,12 +130,12 @@ async function maybeInstallRebar3(rebar3Spec) {
async function getOTPVersion(otpSpec0, osVersion) { async function getOTPVersion(otpSpec0, osVersion) {
const otpVersions = await getOTPVersions(osVersion) const otpVersions = await getOTPVersions(osVersion)
const otpSpec = otpSpec0.match(/^(OTP-)?([^ ]+)/) const otpSpec = otpSpec0.match(/^(OTP-|maint-)?([^ ]+)/)
let otpVersion let otpVersion
if (otpSpec[1]) { if (otpSpec[1] && !isStrictVersion()) {
throw new Error( throw new Error(
`Requested Erlang/OTP version (${otpSpec0}) ` + `Requested Erlang/OTP version (${otpSpec0}) ` +
"should not contain 'OTP-'", "should not contain 'OTP-, or maint-'",
) )
} }
if (otpSpec) { if (otpSpec) {
@@ -169,7 +160,7 @@ async function getElixirVersion(exSpec0, otpVersion) {
const exSpec = exSpec0.match(/^v?(.+)(-otp-.+)/) || exSpec0.match(/^v?(.+)/) const exSpec = exSpec0.match(/^v?(.+)(-otp-.+)/) || exSpec0.match(/^v?(.+)/)
let elixirVersion let elixirVersion
if (exSpec[2]) { if (exSpec[2] && !isStrictVersion()) {
throw new Error( throw new Error(
`Requested Elixir / Erlang/OTP version (${exSpec0} / ${otpVersion}) ` + `Requested Elixir / Erlang/OTP version (${exSpec0} / ${otpVersion}) ` +
"should not contain '-otp-...'", "should not contain '-otp-...'",
@@ -197,9 +188,11 @@ async function getElixirVersion(exSpec0, otpVersion) {
`Using Elixir ${elixirVersion} (built for OTP ${otpVersionMajor})`, `Using Elixir ${elixirVersion} (built for OTP ${otpVersionMajor})`,
) )
} else { } else {
// ... and it's not available: fallback to the 'generic' version (v1.4.5 only). // ... and it's not available: exit with exception
elixirVersionWithOTP = elixirVersion throw new Error(
core.info(`Using Elixir ${elixirVersion}`) `Requested Elixir / Erlang/OTP version (${exSpec0} / ${otpVersion}) not ` +
'found in version list (did you check Compatibility between Elixir and Erlang/OTP?)',
)
} }
} else { } else {
throw new Error( throw new Error(
@@ -258,7 +251,7 @@ async function getOTPVersions(osVersion) {
.trim() .trim()
.split('\n') .split('\n')
.forEach((line) => { .forEach((line) => {
const otpMatch = line.match(/^(OTP-)?([^ ]+)/) const otpMatch = line.match(/^(OTP-|maint-)?([^ ]+)/)
const otpVersion = otpMatch[2] const otpVersion = otpMatch[2]
otpVersions.set(otpVersion, otpMatch[0]) // we keep the original for later reference otpVersions.set(otpVersion, otpMatch[0]) // we keep the original for later reference
}) })
@@ -335,13 +328,14 @@ async function getRebar3Versions() {
return rebar3VersionsListing return rebar3VersionsListing
} }
function isStrictVersion() {
return core.getInput('version-type', { required: false }) === 'strict'
}
function getVersionFromSpec(spec, versions) { function getVersionFromSpec(spec, versions) {
let version = null let version = null
if ( if (spec.match(/rc/) || isStrictVersion()) {
spec.match(/rc/) ||
core.getInput('version-type', { required: false }) === 'strict'
) {
version = spec version = spec
} }
@@ -404,7 +398,9 @@ function getRunnerOSVersion() {
const ImageOSToContainer = { const ImageOSToContainer = {
ubuntu18: 'ubuntu-18.04', ubuntu18: 'ubuntu-18.04',
ubuntu20: 'ubuntu-20.04', ubuntu20: 'ubuntu-20.04',
ubuntu22: 'ubuntu-22.04',
win19: 'windows-2019', win19: 'windows-2019',
win22: 'windows-2022',
} }
const containerFromEnvImageOS = ImageOSToContainer[process.env.ImageOS] const containerFromEnvImageOS = ImageOSToContainer[process.env.ImageOS]
@@ -469,10 +465,12 @@ async function get(url0, pageIdxs) {
} }
function maybePrependWithV(versionToPrepend, specVersion) { function maybePrependWithV(versionToPrepend, specVersion) {
const digitStart = new RegExp('^\\d+') const digitStart = /^\d+/
return digitStart.test(specVersion) let v = versionToPrepend
? `v${versionToPrepend}` if (digitStart.test(specVersion)) {
: versionToPrepend v = `v${versionToPrepend}`
}
return v
} }
module.exports = { module.exports = {
+1 -1
View File
@@ -15,7 +15,7 @@ jobs:
- uses: erlef/setup-beam@v1.9.0 - uses: erlef/setup-beam@v1.9.0
with: with:
otp-version: "23.2" otp-version: "23.2"
gleam-version: "0.19.0-rc3" gleam-version: "0.23.0-rc1"
- run: gleam format --check src test - run: gleam format --check src test
- run: gleam deps download - run: gleam deps download
- run: gleam test - run: gleam test
+2 -2
View File
@@ -2,8 +2,8 @@
# You typically do not need to edit this file # You typically do not need to edit this file
packages = [ packages = [
{ name = "gleam_stdlib", version = "0.19.2", build_tools = ["gleam"], requirements = [], otp_app = "gleam_stdlib", source = "hex", outer_checksum = "FFA79EA12369F122B68885E694E097D6810402A2F86BFF48AAE9E40ACE654F4C" }, { name = "gleam_stdlib", version = "0.22.3", build_tools = ["gleam"], requirements = [], otp_app = "gleam_stdlib", source = "hex", outer_checksum = "F2C2D389B06426E1289D5419F89BDE8E0F7F35A40B2BBB3C88188481F0D44A9F" },
{ name = "gleeunit", version = "0.6.0", build_tools = ["gleam"], requirements = ["gleam_stdlib"], otp_app = "gleeunit", source = "hex", outer_checksum = "77701A5E5A565727E1EEAC9196FB878D544049B6331CD0305B5A69699135EA1C" }, { name = "gleeunit", version = "0.6.2", build_tools = ["gleam"], requirements = ["gleam_stdlib"], otp_app = "gleeunit", source = "hex", outer_checksum = "A006864621DB80C4FBB0746580703502FD81A4D38D23FCB20A8120984D353DF0" },
] ]
[requirements] [requirements]
-23
View File
@@ -1,23 +0,0 @@
name: test
on:
push:
branches:
- master
- main
pull_request:
jobs:
test:
runs-on: ubuntu-latest
steps:
- uses: actions/checkout@v2.0.0
- uses: gleam-lang/setup-erlang@v1.1.2
with:
otp-version: 23.2
- uses: gleam-lang/setup-gleam@v1.0.2
with:
gleam-version: 0.16.1
- run: rebar3 install_deps
- run: rebar3 eunit
- run: gleam format --check src test
-21
View File
@@ -1,21 +0,0 @@
*.beam
*.iml
*.o
*.plt
*.swo
*.swp
*~
.erlang.cookie
.eunit
.idea
.rebar
.rebar3
_*
_build
docs
ebin
erl_crash.dump
gen
log
logs
rebar3.crashdump
-24
View File
@@ -1,24 +0,0 @@
# gleam_rebar3
A Gleam project
## Quick start
```sh
# Run the eunit tests
rebar3 eunit
# Run the Erlang REPL
rebar3 shell
```
## Installation
If [available in Hex](https://rebar3.org/docs/configuration/dependencies/#declaring-dependencies)
this package can be installed by adding `gleam_rebar3` to your `rebar.config` dependencies:
```erlang
{deps, [
gleam_rebar3
]}.
```
-3
View File
@@ -1,3 +0,0 @@
name = "gleam_rebar3"
# repository = { type = "github", user = "my-user", repo = "gleam_rebar3" }
-12
View File
@@ -1,12 +0,0 @@
{erl_opts, [debug_info]}.
{src_dirs, ["src", "gen/src"]}.
{profiles, [
{test, [{src_dirs, ["src", "test", "gen/src", "gen/test"]}]}
]}.
{project_plugins, [rebar_gleam]}.
{deps, [
{gleam_stdlib, "0.16.0"}
]}.
@@ -1,15 +0,0 @@
{application, gleam_rebar3,
[{description, "A Gleam project"},
{vsn, "0.1.0"},
{registered, []},
{applications,
[kernel,
stdlib,
gleam_stdlib
]},
{env,[]},
{modules, []},
{include_files, ["gleam.toml", "gen"]},
{links, []}
]}.
@@ -1,3 +0,0 @@
pub fn hello_world() -> String {
"Hello, from gleam_rebar3!"
}
@@ -1,7 +0,0 @@
import gleam_rebar3
import gleam/should
pub fn hello_world_test() {
gleam_rebar3.hello_world()
|> should.equal("Hello, from gleam_rebar3!")
}